﻿SERVERHOP_VERSION = "1.6"

-- GUI
HOPADDON_WIDTH = 240
HOPADDON_HEIGHT = 110
HOPADDON_HEIGHTOPTIONS = 100
-- globals
HOPADDON_MAX_RESULTS = 100 -- C_LFGList.GetSearchResults() return count and list, #list is always capped at 100 ):


hopAddon = CreateFrame("Frame",nil,UIParent)
hopAddon:SetPoint("CENTER",0,0)
hopAddon:SetFrameStrata("HIGH")
hopAddon:SetFrameLevel(1)
hopAddon:SetWidth(HOPADDON_WIDTH)
hopAddon:SetHeight(HOPADDON_HEIGHT)
hopAddon:SetBackdrop({bgFile = "Interface\\FrameGeneral\\UI-Background-Rock", 
					edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
					tile = true, tileSize = 200, edgeSize = 24, 
					insets = { left = 4, right = 4, top = 4, bottom = 4 }});
hopAddon:SetBackdropColor(1,1,1,1);
hopAddon:Hide()

-- Toggle button attached to LFGListFrame
local toggleButton = CreateFrame("Button",nil,LFGListFrame,"UIPanelButtonTemplate")
toggleButton:SetSize(70,22)
toggleButton:SetPoint("BOTTOM",LFGListFrame,"BOTTOM",-4,5)
toggleButton:SetText(" ServerHop")
toggleButton:SetScript("OnClick", function(btn)
	if hopAddon:IsShown() then
		hopAddon:Hide()
	else
		hopAddon:Show()
	end
end)

toggleButton:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	GameTooltip:SetText(HOPADDON_TOGGLE)
	GameTooltip:Show()
end)
toggleButton:SetScript("OnLeave", function(self) GameTooltip:Hide() end)


SLASH_SERVERHOP1 = "/sh" SLASH_SERVERHOP2 = "/serverhop"
SlashCmdList["SERVERHOP"] = function(msg, editbox)
	hopAddon:Show()
end

-- Variables
hopAddon.var = CreateFrame("Frame")
-- Custom Search Declarations
hopAddon.var.addonSearchRequest = false


-- Functions

function FullScaleSearch(selection, str, filter1, filter2)
	--print("Called search")
	local lang={}
	for k,v in pairs(C_LFGList.GetAvailableLanguageSearchFilter()) do lang[v]=true end
	C_LFGList.ClearSearchResults()
	C_LFGList.Search(selection, str, filter1, filter2, lang)
end

function NotInGroup()
    return (not IsInGroup() and not IsInRaid())
end

function canJoinGroup()
    return (not IsInGroup()) or (UnitIsGroupLeader('player') and not IsInRaid())
end